{% extends "customers/base.html" %}
{% load i18n %}
{% load active_tag %}
{% load widget_tweaks %}
{% load staticfiles %}

{% block title %}Configuración del cliente {{ customer.name }}{% endblock %}

{% block pagelevelcss %}
{% endblock %}

{% block page %}
{%if can_show_detail %}
  <!-- begin breadcrumb -->
  <ol class="breadcrumb float-xl-right">
    <li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
    <li class="breadcrumb-item"><a href="{% url 'customer-list' %}">Clientes</a></li>
    <li class="breadcrumb-item"><a href="{% url 'customer-detail' pk=customer.pk %}">{{ customer.rut }}</a></li>
    <li class="breadcrumb-item active">Configuración de servicio</li>
  </ol>
  <!-- end breadcrumb -->

  <!-- begin page-header -->
  <h1 class="page-header">{{ customer.name }}</h1>
  <!-- end page-header -->

  <ul class="nav nav-pills mb-2">
    <li class="nav-item {% add_active request 'customer-detail' %}">
        <a href="{% url 'customer-detail' customer.pk %}"class="nav-link">
            <span class="d-sm-none">General</span>
            <span class="d-sm-block d-none">General</span>
        </a>
    </li>
    <li class="nav-item {% add_active request 'service-list' %}">
        <a href="{% url 'service-list' customer.pk %}" class="nav-link">
            <span class="d-sm-none">Servicios</span>
            <span class="d-sm-block d-none">Servicios</span>
        </a>
    </li>
    {% if service_preselect %}
    <li class="nav-item {% add_active request 'service-detail' %}">
        <a href="{% url 'service-detail' service_preselect.number %}" class="nav-link">
            <span class="d-sm-none" title="Unico servicio del cliente">#{{service_preselect.number}}</span>
            <span class="d-sm-block d-none" title="Unico servicio del cliente">#{{service_preselect.number}}</span>
        </a>
    </li>
    {% endif %}
    <li class="nav-item {% add_active request 'customer-payment-methods' %}">
        <a href="{% url 'customer-payment-methods' customer.pk %}" class="nav-link">
            <span class="d-sm-none">Métodos de Pago</span>
            <span class="d-sm-block d-none">Métodos de Pago</span>
        </a>
    </li>
    <li class="nav-item {% add_active request 'invoice-list' %}">
        <a href="{% url 'invoice-list' customer.pk %}" class="nav-link">
            <span class="d-sm-none">Estado de Cuenta</span>
            <span class="d-sm-block d-none">Estado de Cuenta</span>
        </a>
    </li>
    <li class="nav-item">
        <a href="#" class="nav-link active">
            <span class="d-sm-none">Configuración</span>
            <span class="d-sm-block d-none">Configuración</span>
        </a>
    </li>
    <li class="nav-item {% add_active request 'invoice-list' %}">
        <a href="{% url 'customer-widget' customer.pk %}" class="nav-link">
            <span class="d-sm-none">Widget</span>
            <span class="d-sm-block d-none">Widget</span>
        </a>
    </li>	
</ul>

<!-- begin row -->
<div class="row">
    <!-- begin col-12 -->
    <div class="col-xl-12 ui-sortable">
      <!-- begin panel -->
      <div class="panel panel-inverse" data-sortable-id="ui-general-1">
        <!-- begin panel-heading -->
        <div class="panel-heading ui-sortable-handle">
          <h4 class="panel-title">Configuración de cliente</h4>
          <div class="panel-heading-btn">
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
          </div>
        </div>
        <!-- end panel-heading -->
        <!-- begin panel-body -->
        <div class="panel-body">
            {% csrf_token %}

            <form>
              <div class="form-group row">
                <label for="id_aceptacion_contrato" class="control-label m-r-10 m-l-10 col-form-label">Cambiar aceptación de contrato:</label>
                <div>
                  <select id="aceptacion_contrato" class="form-control" onchange="getJson()">
                    <option value="">----</option>
                    <option value="1">Aceptado</option>
                    <option value="2">No Aceptado</option>
                    <option value="3">No Definido</option>
                  </select>
                </div>
              </div>
            </form>

            {% if checked_nuevo_cliente_email == 'Si' %}
              <label class="custom-control custom-switch">
                <input type="checkbox" class="custom-control-input" id=email_nuevo_cliente onclick="getJson()" checked>
                <label class="custom-control-label" for="email_nuevo_cliente"> Bloquear envío de correo nuevo cliente</label>
              </label><br>
            {% endif %}
            {% if checked_nuevo_cliente_email == 'No' %}
              <label class="custom-control custom-switch">
                <input type="checkbox" class="custom-control-input" id=email_nuevo_cliente onclick="getJson()">
                <label class="custom-control-label" for="email_nuevo_cliente"> Bloquear envío de correo nuevo cliente</label>
              </label><br>
            {% endif %}

            <pre id="json-display"></pre>
            <button id="send_nuevo_cliente_email" class="btn btn-success" onclick="showModal()">Enviar Cierre de Ventas</button>
            {% if request.user.is_superuser %}
              <button id="save" class="btn btn-success">Guardar cambios</button>
            {% endif %}

            <div class="modal fade" id="confirmationModal" tabindex="-1" role="dialog" aria-labelledby="confirmationModalLabel" aria-hidden="true">
              <div class="modal-dialog" role="document">
                <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="confirmationModalLabel">Revisar</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <form id="formService">
                    <fieldset>
                      <div class="form-group">
                        <label for="sevice_pk" class="control-label m-r-10">Seleccione Servicio al que se le enviará el correo Cierre de Ventas</label>
                        <select id="service_pk" class="form-control">
                          <option value="">---- Seleccione ----</option>
                          {% for i in servicios %}
                          <option value="{{i.0}}">{{i.1}}</option>
                          {% endfor %}
                        </select>
                      </div>
                    </fieldset>
                  </form>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" onclick="send_email()" data-dismiss="modal">Enviar</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
                </div>
                </div>
              </div>
            </div>
        </div>
        <!-- end panel-body -->
      </div>
    </div>
  </div>
  {%else%}
	<div class="alert alert-success"  style="background-color: rgb(245, 156, 26); text-align: center;" role="alert">
		<h4 class="alert-heading">No encontrado</h4>
		<hr>
		<h5 class="mb-0">Cambie de operador o vuelva al listado de clientes.</h5>
	</div>
	{%endif%}
{% endblock %}
{% block pageleveljs %}

<script type="text/javascript" src="{% static 'theme/build/js/pages/jquery.json-editor.min.js' %}"></script>
<script>
    function showModal()
    {
      $('#confirmationModal').modal('show');
    }

    function send_email()
    {
      var csrftoken = $("[name=csrfmiddlewaretoken]").val();
            $.ajaxSetup({
                beforeSend: function(xhr, settings) {
                  xhr.setRequestHeader("X-CSRFToken", csrftoken);
                }
            });
      var service_pk = document.getElementById("service_pk").value;

      var send_data = {"service_pk": service_pk};
      var url = '{% url "manual-cierre-ventas" %}';
      x = $.ajax({
            type: 'POST',
            url: url,
            data: send_data,
            success: function(datos)
            {
              alert(datos.message);
            }
        })
    }

    function getJson() {
        try {
            var csrftoken = $("[name=csrfmiddlewaretoken]").val();
            $.ajaxSetup({
                beforeSend: function(xhr, settings) {
                  xhr.setRequestHeader("X-CSRFToken", csrftoken);
                }
            });

            var nuevo_cliente_email = document.getElementById("email_nuevo_cliente").checked;
            var cambio_aceptacion = document.getElementById("aceptacion_contrato").value;
            const customerId = window.location.pathname.split('/customers/')[1].split('/configuration/')[0];
            $.get(`/customers/${customerId}/configuration/ajax/`+'?'+'nuevoCliente='+nuevo_cliente_email+'&cambioAceptacion='+cambio_aceptacion, function(res) {
                let json = null;
                if (res && res.data) {
                    json = res.data;
                }
                var editor = new JsonEditor('#json-display', json ? json : {});
                $('#save').on('click', function () {
                    const newJson = $('#json-display')[0].innerText
                    console.log(newJson);
                    try{
                      var objeto = JSON.parse(newJson);
                    } catch(e) {
                      alert(e);
                    }
                    var url = '{% url "update-customer-configuration" %}';
                    var send_data = {"nuevoJson": newJson,
                                     "number": customerId};
                    console.log(send_data);
                    $.ajax({
                      type: 'POST',
                      url: url,
                      data: send_data,
                      success: function(datos)
                      {
                        alert("Se han guardado los cambios exitosamente.");
                        location.reload();
                      }
                    })
                    //aqui hago peticion de guardar en el backend enviando newJson
                });
            })
            /*const jsontest = JSON.stringify({
                  "id": 1001,
                  "type": "donut",
                  "name": "Cake",
                  "description": "http://en.wikipedia.org/wiki/Doughnut",
                  "price": 2.55,
                  "available": {
                    "store": 42,
                    "warehouse": 600
                  },
                  "topping": [
                    { "id": 5001, "type": "None" },
                    { "id": 5002, "type": "Glazed" },
                    { "id": 5005, "type": "Sugar" },
                    { "id": 5003, "type": "Chocolate" },
                    { "id": 5004, "type": "Maple" }
                  ]
                })
                
            return JSON.parse(json);*/
        } catch (ex) {
            alert('Formato de JSON incorrecto: ' + ex);
            var errorJson = document.getElementById("errorJson");
            errorJson.innerHTML = "Formato de JSON incorrecto: " + ex;
        }
    }
    getJson()
</script>
{% endblock %}